#!/usr/bin/env groovy

import com.urbancode.anthill3.*
import com.urbancode.anthill3.plugin.mercurial.*

final def workDir = new File('.').canonicalFile
final def out = System.out
final def env = System.getenv()

//------------------------------------------------------------------------------
// GET ALL INPUT PARAMETERS
//------------------------------------------------------------------------------

final def ahpTool = new AHPTool();
final stepProps = ahpTool.getStepProperties()
final blProps = ahpTool.getBuildLifeProperties()

final def srcName      = stepProps['source'];
final String username  = stepProps['source/repo/username']
final String password  = stepProps['source/repo/password']
final def dir          = new File(workDir, stepProps['source/dirOffset'] ?: '.').canonicalFile // get checkout directory

final def cmdHelper = new CommandHelper(dir);

//------------------------------------------------------------------------------
// PREPARE WORKING DIRECTORY
//------------------------------------------------------------------------------

  // create the working directory
  dir.mkdirs()
  if (!dir.exists()) {
    throw new Exception("Could not create working directory ${workDir}")
  }
  else if (dir.isFile()) {
    throw new Exception("Specified working directory is a file!! ${workDir}")
  }

//------------------------------------------------------------------------------
// PREPARE COMMAND LINE
//------------------------------------------------------------------------------

 println "Deleteing directory contents for $dir"
 dir.listFiles().each{ file ->
     boolean success = false;
     if (file.isFile()) {
         success = file.delete()
     }
     else if (file.isDirectory()){
         success = file.deleteDir()
     }
     if (!success) {
         println("Failed to delete $file")
     }
 }
 println "Done deleting directory contents for $dir"
