import com.urbancode.anthill3.domain.property.PropertyValue;

def stream = triggerPropertyMap['stream']
def revision = triggerPropertyMap['revision']
log.debug("Trigger notified of changes to stream: $stream")

if (stream) {
    for (sc in availableSourceConfigSet) {
        for (module in sc.getPropertyValueGroups()) {
            def scStream = ParameterResolver.resolveForSourceConfig(module.getPropertyValue("stream")?.getValue(), sc)
            if (scStream && scStream.size() > 0) {
                if (stream.equalsIgnoreCase(scStream)) {
                    matchingSourceConfigSet.add(sc)
                    log.debug("Found matching source config from project $sc.project.name")
                    if (revision) {
                        requestPropertyMap["workspace.revision.${module.name}"] = new PropertyValue(revision, false);
                    }
                }
                else {
                    log.debug("Trigger did not match source config from project $sc.project.name")
                }
            }
        }
    }
}
else {
    log.warn("Could not process Accurev repo trigger data: $triggerPropertyMap - invalid stream parameter")
}